#ifndef __NEWTON_H__
#define __NEWTON_H__

#include "Fct.h"

class Newton
{
private:
	Fct *f_;
	double eps_;
	double xmin_;
	double xmax_;
	int maxiter_;

	double *abscisse_;
	double *res_;
	int N_;

public:
	Newton(Fct *f, double eps, double xmin, double xmax, int maxiter);

public:
	int get_size() { return N_; }
	double *get_abscisse() { return abscisse_; }
	double *get_res() { return res_; }
	double operator()(double x0);
	void discretisation(int N);
};

#endif // __NEWTON_H__
