#include "polynom.h"

static double monom(double x, int d)
{
	double val = 1.0;

	for (; d > 0; d--)
		val *= x;

	return val;
}

Polynom::Polynom(double *coefs, int size)
{
	size_ = size;
	coefs_ = coefs;
}

double Polynom::operator()(double x) const
{
	double val = 0.0;

	for (int i = 0; i < size_; i++)
		val += coefs_[i] * monom(x, i);

	return val;
}

double Polynom::fct(double x) const
{
	double val = 0.0;

	for (int i = 1; i < size_; i++)
		val += i * coefs_[i] * monom(x, i - 1);

	return val;
}

double Polynom::der(double x) const
{
	double val = 0.0;

	for (int i = 2; i < size_; i++)
		val += i * (i - 1) * coefs_[i] * monom(x, i - 2);

	return val;
}
