#ifndef __POLYNOM_H__
#define __POLYNOM_H__

#include "fct.h"

class Polynom : public Fct
{
private:
	double *coefs_;
	int size_;

public: // stuctors
	Polynom(double *coefs, int size);

private:
	double operator()(double x) const;
	virtual double fct(double x) const;
	virtual double der(double x) const;

public: // factory
	static Fct *create(double *coefs, int size)
	{
		return dynamic_cast<Fct *>(new Polynom(coefs, size));
	}
};

#endif // __POLYNOM_H__
