#include <iostream>

#include "xdeux.h"
#include "polynom.h"
#include "newton.h"

int main()
{
	Fct *xd = XDeux::create();

	std::cout << xd->fct(2.0) << std::endl;

	try
	{
		Newton n(xd, 0.000001, -2, 2, 10000);
		std::cout << n(2.0) << std::endl;
		n.discretisation(20);
		for (int i = 0; i < n.get_size(); i++)
		{
			std::cout << n.get_abscisse()[i] << " " << n.get_res()[i] << std::endl;
		}
	}
	catch (char *s)
	{
		std::cout << s << std::endl;
	}

	delete xd;

	double coefs[4] = { 1.0, 2.0, 4.0, 3.0 };
	Fct *pol = Polynom::create(coefs, 4);

	std::cout << pol->fct(2.0) << std::endl;
	std::cout << pol->der(-2.0) << std::endl;

	delete pol;

  return 0;
}
